Index: doc/bsp_howto/Makefile
===================================================================
--- doc/bsp_howto/Makefile	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/Makefile	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -45,5 +45,5 @@
 $(PROJECT).dvi: $(FILES)
 	$(TEXI2DVI) $(PROJECT).texi
-	$(TEXI2DVI) $(PROJECT).texi
+	texi2dvi $(PROJECT).texi
 
 html: dirs $(FILES)
@@ -56,5 +56,12 @@
 	rm -f *.dvi *.ps *.log *.aux *.cp *.fn *.ky *.pg *.toc *.tp *.vr $(BASE)
 	rm -f $(PROJECT) $(PROJECT)-* $(GENERATED_FILES)
-	rm -f *.fixed _*
+	rm -f *.fixed _* network.t
+
+#
+#  Grab the chapter on writing a network device driver.
+#
+network.t: 
+	ln -s ../networking/driver.t  network.t
+
 
 #
@@ -80,5 +87,5 @@
 	$(BMENU) -p "Makefiles Creating a New BSP Make Customization File" \
 	    -u "Top" \
-	    -n "Required Support Routines" ${*}.t
+	    -n "Miscellaneous Support Files" ${*}.t
 
 support.texi: support.t Makefile
Index: doc/bsp_howto/analog.t
===================================================================
--- doc/bsp_howto/analog.t	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/analog.t	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -9,4 +9,155 @@
 @chapter Analog Driver
 
-XXX FILL ME IN
+The Analog driver is responsible for providing an
+interface to Digital to Analog Converters (DACs) and 
+Analog to Digital Converters (ADCs).  The capabilities provided
+by this class of device driver are:
 
+@itemize @bullet
+@item Initialize an Analog Board
+@item Open a Particular Analog
+@item Close a Particular Analog
+@item Read from a Particular Analog
+@item Write to a Particular Analog
+@item Reset DACs
+@item Reinitialize DACS
+@end itemize
+
+Most analog devices are found on I/O cards that support multiple 
+DACs or ADCs on a single card.
+
+There are currently no analog device drivers included in the 
+RTEMS source tree.  The information provided in this chapter
+is based on drivers developed by OAR Corporation personnel
+for applications using RTEMS.   It is hoped that this
+driver model information can form the basis for a standard
+analog driver model that can be supported in future RTEMS
+distribution.
+
+@section Major and Minor Numbers
+
+The @b{major} number of a device driver is its index in the 
+RTEMS Device Address Table.
+
+A @b{minor} number is associated with each device instance
+managed by a particular device driver.  An RTEMS minor number 
+is an @code{unsigned32} entity.  Convention calls 
+dividing the bits in the minor number down into categories
+like the following:
+
+@itemize @bullet
+
+@item @b{board} - indicates the board a particular device is located on
+@item @b{port} - indicates the particular device on a board.
+
+@end itemize
+
+From the above, it should be clear that a single device driver
+can support multiple copies of the same board in a single system.
+The minor number is used to distinguish the devices.
+
+@section Analog Driver Configuration
+
+There is not a standard analog driver configuration table but some
+fields are common across different drivers.  The analog driver
+configuration table is typically an array of structures with each
+structure containing the information for a particular board.
+The following is a list of the type of information normally required
+to configure an analog board:
+
+@table @b
+@item board_offset
+is the base address of a board.
+
+@item DAC_initial_values
+is an array of the voltages that should be written to each DAC
+during initialization.  This allows the driver to start the board
+in a known state.
+
+@end table
+
+@section Initialize an Analog Board
+
+At system initialization, the analog driver's initialization entry point
+will be invoked.  As part of initialization, the driver will perform
+whatever board initializatin is required and then set all
+outputs to their configured initial state.
+
+The analog driver may register a device name for each DAC and ADC in
+the system.
+
+@section Open a Particular Analog
+
+This is the driver open call.  Usually this call does nothing other than
+validate the minor number.  
+
+With some drivers, it may be necessary to allocate memory when a particular
+device is opened.  If that is the case, then this is often the place
+to do this operation.
+
+@section Close a Particular Analog
+
+This is the driver close call.  Usually this call does nothing.
+
+With some drivers, it may be necessary to allocate memory when a particular
+device is opened.  If that is the case, then this is the place
+where that memory should be deallocated.
+
+@section Read from a Particular Analog
+
+This corresponds to the driver read call.  After validating the minor
+number and arguments, this call reads the indicated device.  Most analog
+devices store the last value written to a DAC.  Since DACs are output 
+only devices, saving the last written value gives the appearance that
+DACs can be read from also.  If the device is an ADC, then it is sampled.
+
+@b{NOTE:} Many boards have multiple analog inputs but only one ADC.  On
+these boards, it will be necessary to provide some type of mutual exclusion
+during reads.  On these boards, there is a MUX which must be switched 
+before sampling the ADC.  After the MUX is switched, the driver must
+delay some short period of time (usually microseconds) before the 
+signal is stable and can be sampled.  To make matters worse, some ADCs 
+cannot respond to wide voltage swings in a single sample.  On these
+ADCs, one must do two samples when the voltage swing is too large.
+On a practical basis, this means that the driver usually ends up
+double sampling the ADC on these systems.
+
+The value returned is a single precision floating point number 
+representing the voltage read.  This value is stored in the
+@code{argument_block} passed in to the call.  By returning the 
+voltage, the caller is freed from having to know the number of
+bits in the analog and board dependent conversion algorithm.
+
+@section Write to a Particular Analog
+
+This corresponds to the driver write call.  After validating the minor
+number and arguments, this call writes the indicated device.  If the
+specified device is an ADC, then an error is usually returned.  
+
+The value written is a single precision floating point number
+representing the voltage to be written to the specified DAC.  
+This value is stored in the @code{argument_block} passed in to the
+call.  By passing the voltage to the device driver, the caller is
+freed from having to know the number of bits in the analog
+and board dependent conversion algorithm.
+
+@section Reset DACs
+
+This is one of the IOCTL functions supported by the I/O control
+device driver entry point.  When this IOCTL function is invoked,
+all of the DACs are written to 0.0 volts.
+
+@section Reinitialize DACS
+
+This is one of the IOCTL functions supported by the I/O control
+device driver entry point.  When this IOCTL function is invoked,
+all of the DACs are written with the initial value configured
+for this device.
+
+@section Get Last Written Values
+
+This is one of the IOCTL functions supported by the I/O control
+device driver entry point.  When this IOCTL function is invoked,
+the last value written to the specified output word along with
+a timestamp of when the last write was performed.
+
Index: doc/bsp_howto/clock.t
===================================================================
--- doc/bsp_howto/clock.t	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/clock.t	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -11,36 +11,119 @@
 @section Introduction
 
-The clock driver aims at giving a steady time basis to the kernel, so that
-the RTEMS primitives that need a clock tick work properly. <insert a link
-to the Clock Driver defs>
+The purpose of the clock driver is to provide a steady time
+basis to the kernel, so that the RTEMS primitives that need
+a clock tick work properly.  See the @code{Clock Manager} chapter
+of the @b{RTEMS Application C User's Guide} for more details.
 
-The clock driver is located in the clock directory of the BSP. 
+The clock driver is located in the @code{clock} directory of the BSP. 
 
-@section Primitives
+@section Clock Driver Global Variables
 
-@subsection Initialization
+@subsection Major and Minor Number
 
-The major and minor numbers of the clock driver can be made available to
-the others, such as the Shared Memory Driver. 
+The major and minor numbers of the clock driver are made available via 
+the following variables.  
 
-Then you have to program your integrated processor periodic interval timer
-so that an interrupt is generated every m microseconds, where m =
-BSP_Configuration.microseconds_per_tick. Sometimes the periodic interval
+@itemize @bullet
+@item rtems_device_major_number rtems_clock_major;
+@item rtems_device_minor_number rtems_clock_minor;
+@end itemize
+
+The clock device driver is responsible for declaring and
+initializing these variables.  These variables are used
+by other RTEMS components -- notably the Shared Memory Driver. 
+
+@b{NOTE:} In a future RTEMS version, these variables may be replaced
+with the clock device driver registering @b{/dev/clock}.
+
+@subsection Ticks Counter
+
+Most of the clock device drivers provide a global variable
+that is simply a count of the number of clock driver interrupt service
+routines that have occured.  This information is valuable when debugging
+a system.  This variable is declared as follows:
+
+@example
+volatile rtems_unsigned32 Clock_driver_ticks;
+@end example
+
+@section Initialization
+
+The initialization routine is responsible for
+programming the hardware that will periodically
+generate an interrupt.  A programmable interval timer is commonly
+used as the source of the clock tick.
+
+The device should be programmed such that an interrupt is generated
+every @i{m} microseconds, where @i{m} is equal to 
+@code{BSP_Configuration.microseconds_per_tick}. Sometimes the periodic interval
 timer can use a prescaler so you have to look carefully at your user's
 manual to determine the correct value. 
 
-You must use the RTEMS primitive to put your clock interrupt routine in
-the VBR: 
+You must use the RTEMS primitive @code{rtems_interrupt_catch} to install
+your clock interrupt service routine:
 
 @example
-rtems_interrupt_catch (InterruptHandler, CONSOLE_VECTOR, &old_handler); 
+rtems_interrupt_catch (Clock_ISR, CLOCK_VECTOR, &old_handler); 
 @end example
 
-@subsection The Clock Interrupt Subroutine
+Since there is currently not a driver entry point invoked at system
+shutdown, many clock device drivers use the @code{atexit} routine
+to schedule their @code{Clock_exit} routine to execute when the
+system is shutdown.
+
+By convention, many of the clock drivers do not install the clock
+tick if the @code{ticks_per_timeslice} field of the Configuration
+Table is 0.
+
+@section System shutdown
+
+Many drivers provide the routine @code{Clock_exit} that is scheduled
+to be run during system shutdown via the @code{atexit} routine.
+The @code{Clock_exit} routine will disable the clock tick source
+if it was enabled.  This can be used to prevent clock ticks after the
+system is shutdown.
+
+@section Clock Interrupt Subroutine
 
 It only has to inform the kernel that a ticker has elapsed, so call : 
 
 @example
-rtems_clock_tick(); 
+@group
+rtems_isr Clock_isr( rtems_vector_number vector )
+@{
+  invoke the rtems_clock_tick() directive to announce the tick
+  if necessary for this hardware
+    reload the programmable timer
+@}
+@end group
 @end example
 
+@section IO Control
+
+The clock driver must supply a handler for the IO control device driver
+entry point.  This functionality is used by other components -- notably
+the Shared Memory Driver to install a wrapper for the clock interrupt
+service routine.  The following shows the functionality required:
+
+@example
+@group
+rtems_device_driver Clock_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+@{
+  error check the argument pointer parameter
+
+  if the command is "ISR"
+    invoke the clock interrupt service routine
+  else if the command is "NEW"
+    install the requested handler
+@}
+@end group
+@end example
+
+
+
+
Index: doc/bsp_howto/console.t
===================================================================
--- doc/bsp_howto/console.t	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/console.t	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -11,14 +11,20 @@
 @section Introduction
 
-This chapter describes how to do a console driver using RTEMS Termios
-support. 
-
-The serial driver is called as soon as printf/scanf or read/write kind of
-input/output are needed. There are two main functioning modes: 
+This chapter describes the operation of a console driver using 
+the RTEMS POSIX Termios support.  Traditionally RTEMS has referred
+to all serial device drivers as console device drivers.  A
+console driver can be used to do raw data processing in addition
+to the "normal" standard input and output device functions required
+of a console.
+
+The serial driver may be called as the consequence of a C Library
+call such as @code{printf} or @code{scanf} or directly via the
+@code{read} or @code{write} system calls. 
+There are two main functioning modes: 
 
 @itemize @bullet
 
 @item console: formatted input/output, with special characters (end of
-line, tabulations, etc...) recognition and processing,
+line, tabulations, etc.) recognition and processing,
 
 @item raw: permits raw data processing. 
@@ -31,14 +37,18 @@
 @section Termios
 
-Termios is a standard for terminal management, included in several Unix
-versions. Termios is good because: 
-
-@itemize @bullet
-
-@item from the user's side: primitives to access the terminal and change
-configuration settings are the same under Unix and Rtems. 
-
-@item from the BSP developer's side: it frees you from dealing with buffer
-states and mutual exclusions on them. 
+Termios is a standard for terminal management, included in the POSIX 1003.1b
+standard.  It is commonly provided on UNIX implementations.  
+Having RTEMS support for Termios is beneficial:
+
+@itemize @bullet
+
+@item from the user's side because it provides standard primitive operations
+to access the terminal and change configuration settings.  These operations
+are the same under Unix and Rtems. 
+
+@item from the BSP developer's side because it frees the
+developer from dealing with buffer states and mutual exclusions on them. 
+Early RTEMS console device drivers also did their own special
+character processing.
 
 @end itemize
@@ -55,6 +65,14 @@
 @end itemize
 
-For more information on Termios, type man termios in your Unix box or go
-to http://www.freebsd.org/cgi/man.cgi. 
+At this time, RTEMS documentation does not include a thorough discussion
+of the Termios functionality.  For more information on Termios,
+type @code{man termios} on a Unix box or point a web browser
+at
+@ifset use-html
+@href{http://www.freebsd.org/cgi/man.cgi,,,http://www.freebsd.org/cgi/man.cgi}.
+@end ifset
+@ifclear use-html
+@code{http://www.freebsd.org/cgi/man.cgi}.
+@end ifclear
 
 @section Driver Functioning Modes
@@ -65,25 +83,50 @@
 @itemize @bullet
 
-@item polling mode: the processor blocks on sending/receiving characters.
-This mode is not powerful, but is necessary when one wants to print an
-error message when the board hung. This is also the most simple mode to
-program,
-
-@item interrupt mode: the processor doesn't block on sending/receiving
-characters. Two buffers (one for the in-going characters, the others for
-the characters to be sent) are used. An interrupt is raised as soon as a
-character is in the UART. Then the int errupt subroutine insert the
-character at the input buffer queue. When a character is asked for input,
-this at the head of the buffer is returned. When characters have to be
-sent, one have to put the first characters (the number depends on the
-UART) in th e UART. Then an interrupt is raised when all the characters
-have been emitted. The interrupt subroutine has to send the characters
-remaining in the output buffer the same way. 
-
-@end itemize
+@item polled mode
+@item interrupt driven mode
+
+@end itemize
+
+In polled mode, the processor blocks on sending/receiving characters.
+This mode is not the most efficient way to utilize the UART. But 
+polled mode is usually necessary when one wants to print an
+error message in the event of a fatal error such as al fatal error
+in the BSP.  This is also the simplest mode to
+program.  Polled mode is generally preferred if the serial port is
+to be used primarily as a debug console.  In a simple polled driver,
+the software will continuously check the status of the UART when
+it is reading or writing to the UART.  Termios improves on this
+by delaying the caller for 1 clock tick between successive checks
+of the UART on a read operation.
+
+In interrupt driven mode, the processor does not block on sending/receiving
+characters.  Data is buffered between the interrupt service routine
+and application code.  Two buffers are used to insulate the application
+from the relative slowness of the serial device.  One of the buffers is
+used for incoming characters, while the other is used for outgoing characters.
+
+An interrupt is raised when a character is received by the UART.
+The interrupt subroutine places the incoming character at the end
+of the input buffer.  When an application asks for input,
+the characters at the front of the buffer are returned.
+
+When the application prints to the serial device, the outgoing characters
+are placed at the end of the output buffer.  The driver will place
+one or more characters in the UART (the exact number depends on the UART)
+An interrupt will be raised when all the characters have been transmitted.
+The interrupt service routine has to send the characters
+remaining in the output buffer the same way.   When the transmitting side
+of the UART is idle, it is typically necessary to prime the transmitter 
+before the first interrupt will occur.
 
 @section Serial Driver Functioning Overview
 
-Figure 5 is an attempt of showing how a Termios driven serial driver works : 
+The following Figure shows how a Termios driven serial driver works: 
+
+@example
+This figure needs to be inserted in this document.
+@end example
+
+The following list describes the basic flow.
 
 @itemize @bullet
@@ -92,9 +135,9 @@
 scanf, read, write, etc.),
 
-@item C library (in fact that's Cygnus Newlib) calls RTEMS procedure: glue
-is made in newlib*.c files which can be found under
-$RTEMS_ROOT/c/src/lib/libc directory,
-
-@item Glue code calls your serial driver entry routines. 
+@item C library (in fact that's Cygnus Newlib) calls RTEMS 
+system call interface. This code can be found in the 
+@code{c/src/lib/libc} directory.
+
+@item Glue code calls the serial driver entry routines. 
 
 @end itemize
@@ -102,24 +145,44 @@
 @subsection Termios and Polled I/O
 
-You have to point Termios out which functions are used for simple
-character input/output: 
-
-
-Function
-
-Description
-
-@example
+The following functions are provided by the driver and invoked by
+Termios for simple character input/output.  The specific names of
+these routines are not important as Termios invokes them indirectly
+via function pointers.
+
+@subsubsection pollWrite
+
+The @code{pollWrite} routine is responsible for writing @code{len} characters
+from @code{buf} to the serial device specified by @code{minor}.
+
+@example
+@group
 int pollWrite (int minor, const char *buf, int len) 
-
-for (i=0; i<len; i++) @{
+@{
+  for (i=0; i<len; i++) @{
      put buf[i] into the UART channel minor
      wait for the character to be transmitted
      on the serial line
+  @}
 @}
-int pollread(int minor)
-@end example
-
-wait for a character to be available in the UART channel minor, then return it.
+@end group
+@end example
+
+@subsubsection pollRead
+
+The @code{pollRead} routine is responsible for reading a single character
+from the serial device specified by @code{minor}.  If no character is
+available, then the routine should return -1.
+
+@example
+@group
+int pollRead(int minor)
+@{
+   read status of UART
+   if status indicates a character is available
+     return character
+   return -1
+@}
+@end group
+@end example
 
 @subsection Termios and Interrupt Driven I/O
@@ -127,56 +190,84 @@
 The UART generally generates interrupts when it is ready to accept or to
 emit a number of characters. In this mode, the interrupt subroutine is the
-core of the driver: 
-
-@example
+core of the driver.
+
+@subsubsection InterruptHandler
+
+The @code{InterruptHandler} is responsible for processing asynchronous
+interrupts from the UART.  There may be multiple interrupt handlers for
+a single UART.  Some UARTs can generate a unique interrupt vector for
+each interrupt source such as a character has been received or the
+transmitter is ready for another character.
+
+In the simplest case, the @code{InterruptHandler} will have to check 
+the status of the UART and determine what caused the interrupt.
+The following describes the operation of an @code{InterruptHandler} 
+which has to do this:
+
+@example
+@group
 rtems_isr InterruptHandler (rtems_vector_number v)
-@end example
-
-check whether there was an error
-
-if some characters were received: 
-   ask Termios to put them on his input buffer
-
-if some characters have been transmitted (i.e. the UART output buffer is empty)
-   tell TERMIOS that the characters have been
-   transmitted. The TERMIOS routine will call
-   the InterruptWrite function with the number
-   of characters not transmitted yet if it is
-   not zero.
+@{
+  check whether there was an error
+
+  if some characters were received: 
+     Ask Termios to put them on his input buffer
+
+  if some characters have been transmitted
+        (i.e. the UART output buffer is empty)
+     Tell TERMIOS that the characters have been
+     transmitted. The TERMIOS routine will call
+     the InterruptWrite function with the number
+     of characters not transmitted yet if it is
+     not zero.
+@}
+@end group
+@end example
+
+@subsubsection InterruptWrite
+
+The @code{InterruptWrite} is responsible for telling the UART 
+that the @code{len} characters at @code{buf} are to be transmitted.
 
 @example
 static int InterruptWrite(int minor, const char *buf, int len)
-@end example
-
-you have to put the n first buf characters in the UART channel minor
-buffer (n is the UART channel size, n=1 on the MC68640). Generally, an
-interrupt is raised after these n characters being transmitted. So you may
-have to enable the UART interrupts after having put the characters in the
+@{
+   tell the UART to transmit len characters from buf
+@}
+@end example
+
+The driver has to put the @i{n} first buf characters in the UART channel minor
+buffer (@i{n} is the UART channel size, @i{n}=1 on the MC68640). Generally, an
+interrupt is raised after these @i{n} characters being transmitted. So
+UART interrupts may have to be enabled after putting the characters in the
 UART. 
 
 
-Figure 5: general TERMIOS driven serial driver functioning
-
 @subsection Initialization
 
-The driver initialization is called once during RTEMS initialization
+The driver initialization is called once during the RTEMS initialization
 process. 
 
-The console_initialize function has to : 
-
-@itemize @bullet
-
-@item initialize Termios support: call rtems_termios_initialize(),
-
-@item initialize your integrated processor's UART: the operation is
-normally described in your user's manual and you must follow these
-instructions but it usually consists in: 
-
-@item reinitialize the UART channels,
-
-@item set the channels configuration to Termios default one, i.e.: 9600
-bauds, no parity, 1 stop bit, 8 bits per character,
-
-@item register your console interrupt routine to RTEMS: 
+The @code{console_initialize} function has to: 
+
+@itemize @bullet
+
+@item initialize Termios support: call @code{rtems_termios_initialize()}.  If
+Termios has already been initialized by another device driver, then
+this call will have no effect.
+
+@item Initialize the UART: This procedure should
+be described in the UART manual.  This procedure @b{MUST} be
+followed precisely.  This procedure varies but 
+usually consists of: 
+
+@itemize @bullet
+@item reinitialize the UART channels
+
+@item set the channels configuration to the Termios default:
+9600 bauds, no parity, 1 stop bit, and 8 bits per character
+@end itemize
+
+@item If interrupt driven, register the console interrupt routine to RTEMS:
 
 @example
@@ -184,9 +275,9 @@
 @end example
 
-@item enable the UART channels,
-
-@item register your device name: in order to use the console (i.e. being
-able to do printf/scanf on stdin, stdout, and stderr), you have to
-register the "/dev/console" device: 
+@item enable the UART channels.
+
+@item register the device name: in order to use the console (i.e. being
+able to do printf/scanf on stdin, stdout, and stderr), some device
+must be registered as "/dev/console":
 
 @example
@@ -198,72 +289,91 @@
 @subsection Opening a serial device
 
-The console device is opened during RTEMS initialization but the
-console_open function is called when a new device is opened. For instance,
-if you register the "/dev/tty1" device for the UART channel 2, the
-console_open will be called with a fopen("/dev/t ty", mode) in your
+The @code{console_open} function is called whenever a serial
+device is opened.  The device registered as @code{"/dev/console"}
+is opened automatically during RTEMS initialization.
+For instance, if UART channel 2 is registered as "/dev/tty1",
+the @code{console_open} entry point will be called as
+the result of an @code{fopen("/dev/tty1", mode)} in the
 application. 
 
-The console_open function has to inform Termios of your low-level function
-for serial line support; the "callbacks". 
-
-The gen68340 BSP defines two kinds of callbacks: 
-
-@itemize @bullet
-
-@item functions to use with polled input/output,
-
-@item functions to use with interrupt input/output. 
-
-@end itemize
+The @code{console_open} function has to inform Termios of the low-level
+functions for serial line support; the "callbacks". 
+
+The gen68340 BSP defines two sets of callback tables: 
+
+@itemize @bullet
+
+@item one with functions for polled input/output
+
+@item another with functions for interrupt driven input/output 
+
+@end itemize
+
+This code can be found in the file @code{$BSPROOT/console/console.c}.
 
 @subsubsection Polled I/O
 
-You have to point Termios out which functions are used for simple
-character input/output, i.e. pointers to pollWrite and pollRead functions
-defined in 8.4.1. 
+Termios must be told the addresses of the functions that are to be 
+used for simple character input/output, i.e. pointers to the
+@code{pollWrite} and @code{pollRead} functions
+defined earlier in @ref{Console Driver Termios and Polled I/O}.
 
 @subsubsection Interrupt Driven I/O
 
-Driver functioning is quite different in this mode. You can see there's no
-read function passed to Termios. Indeed a console_read call returns the
-content of Termios input buffer. This buffer is filled in the driver
-interrupt subroutine (cf. 8.4.2). 
-
-But you actually have to provide a pointer to the InterruptWrite function. 
-
-@subsection Closing a serial device
-
-The driver entry point is: console_close. 
-
-You just have to notify Termios that the serial device was closed, with a
-call to rtems_termios_close. 
-
-@subsection Reading characters from the serial device
-
-The driver entry point is: console_read. 
-
-You just have to return the content of the Termios input buffer. 
-
-Call rtems_termios_read. 
-
-@subsection Writing characters to the serial device
-
-The driver entry point is: console_write. 
-
-You just have to add the characters at the end of the Termios output
+Driver functioning is quite different in this mode.  There is no
+device driver read function to be passed to Termios. Indeed a
+@code{console_read} call returns the contents of Termios input buffer.
+This buffer is filled in the driver interrupt subroutine
+(see @ref{Console Driver Termios and Interrupt Driven I/O}).
+
+The driver is responsible for providing a pointer to the 
+@code{InterruptWrite} function. 
+
+@subsection Closing a Serial Device
+
+The @code{console_close} is invoked when the serial device is to
+be closed.  This entry point corresponds to the device driver
+close entry point.
+
+This routine is responsible for notifying Termios that the serial
+device was closed.  This is done with a call to @code{rtems_termios_close}. 
+
+@subsection Reading Characters From a Serial Device
+
+The @code{console_read} is invoked when the serial device is to
+be read from.  This entry point corresponds to the device driver
+read entry point.
+
+This routine is responsible for returning the content of the
+Termios input buffer.   This is done by invoking the
+@code{rtems_termios_read} routine. 
+
+@subsection Writing Characters to a Serial Device
+
+The @code{console_write} is invoked when the serial device is to
+be written to.  This entry point corresponds to the device driver
+write entry point.
+
+This routine is responsible for adding the requested characters to
+the Termios output queue for this device.  This is done by
+calling the routine @code{rtems_termios_write} 
+to add the characters at the end of the Termios output
 buffer. 
 
-Call rtems_termios_write. 
-
-@subsection Changing serial line parameters
-
-The driver entry point is: console_control. 
+@subsection Changing Serial Line Parameters
+
+The @code{console_control} is invoked when the line parameters
+for a particular serial device are to be changed.
+This entry point corresponds to the device driver
+io_control entry point.
 
 The application write is able to control the serial line configuration
-with Termios calls (such as the ioctl command, see Termios man page for
-more details). If you want to support dynamic configuration, you have to
-write the console_control piece of code . Look at the gen68340 BSP for an
-example of how it is done. Basically ioctl commands call console_control
-with the serial line configuration in a Termios structure. You just have
-to reinitialize the UART with the correct settings. 
-
+with Termios calls (such as the @code{ioctl} command, see 
+the Termios documentation for
+more details). If the driver is to support dynamic configuration, then
+is must have the @code{console_control} piece of code. Refer to the gen68340
+BSP for an example of how it is done.  Basically @code{ioctl} 
+commands call @code{console_control} with the serial line
+configuration in a Termios defined data structure. The driver
+is responsible for reinitializing the UART with the correct settings. 
+
